#
# spec file for package bash (Version 2.05b)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# neededforbuild  bison
# usedforbuild    aaa_base acl attr bash bind9-utils bison cpio cpp cyrus-sasl db devs diffutils e2fsprogs file filesystem fileutils fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip kbd less libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam pam-devel pam-modules patch permissions ps rcs readline sed sendmail sh-utils shadow strace syslogd sysvinit tar texinfo textutils timezone unitedlinux-release unzip util-linux vim zlib-devel autoconf automake binutils bzip2 cracklib gcc gdbm gettext libtool perl rpm zlib

Name:           bash
License:        GNU General Public License (GPL)
Group:          System/Shells
Requires:       readline >= 4.3
Autoreqprov:    on
Version:        2.05b
Release:        311
%define       bash_vers 2.05b
%define       rl_vers 4.3
Summary:        The GNU Bourne-Again Shell
Source0:        bash-%{bash_vers}.tar.bz2
Source1:        readline-%{rl_vers}.tar.bz2
Patch0:         bash-%{bash_vers}.dif
Patch1:         readline-%{rl_vers}.dif
Patch2:         readline-%{rl_vers}-destdir.patch
Patch3:         bash-2.03-manual.patch
Patch4:         bash-2.05b-readline.patch
Patch5:         bash-2.05a-security.patch
Patch7:         bash-2.05-2.4.4.patch
Patch8:         bash-2.05b-locale.patch
Patch9:         bash-2.05b-display.patch
Patch10:        bash-2.05b-display-mbspeed.patch
Patch11:        bash-2.05b-restricted-login-shell.patch
Patch12:        bash-2.05b-noediting.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Bash is a sh-compatible command interpreter that executes commands read
from standard input or from a file.  Bash also incorporates useful
features from the Korn and C shells (ksh and csh).  Bash is ultimately
intended to be a conformant implementation of the IEEE Posix Shell and
Tools specification (IEEE Working Group 1003.2).



Authors:
--------
    Brian Fox <bfox@gnu.org>
    Chet Ramey <chet@ins.cwru.edu>

%package -n readline
Summary:        The readline library
Group:          System/Libraries
Provides:       bash:/lib/libreadline.so.4
Version:        4.3
Release:        312
Autoreqprov:    on

%description -n readline
The readline library is used e.g. by the Bourne Again Shell (bash, the
standard comand interpreter) for a easy edtiting of comand lines.  You
will find a history and search functionality for doing that.



Authors:
--------
    Brian Fox <bfox@gnu.org>
    Chet Ramey <chet@ins.cwru.edu>

%package -n readline-devel
Summary:        The readline library link kit
Group:          Development/Libraries/C and C++
Provides:       bash:/usr/lib/libreadline.a
Requires:       readline = %{version}-%{release}
Version:        4.3
Release:        312
Autoreqprov:    on

%description -n readline-devel
This package includes the header files, manual pages, and the libraries
used by the linker to include the readline library into a program.



Authors:
--------
    Brian Fox <bfox@gnu.org>
    Chet Ramey <chet@ins.cwru.edu>

%prep
%setup -n bash-%{bash_vers}
%patch3  -p0 -b .manual
%patch4  -p0 -b .readline
%patch5  -p0 -b .security
%patch7  -p0 -b .2.4.4
%patch8  -p0 -b .locale
%patch9  -p0 -b .display
%patch10 -p0 -b .display-mbspeed
%patch11 -p1 -b .rbash
%patch12
%patch0  -p0
%setup -T -n readline-%{rl_vers} -b1
%patch9  -p2 -b .display
%patch10 -p2 -b .display-mbspeed
%patch1  -p0
%patch2  -p0

%build
%{?suse_update_config:%{suse_update_config -f support}}
CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -Wall -pipe -g"
    CC=gcc
export CC CFLAGS
  autoconf
  ./configure --build=%{_target_cpu}-suse-linux \
	--prefix=/usr			\
	--with-curses			\
	--mandir=%{_mandir}		\
	--infodir=%{_infodir}		\
	--libdir=%{_libdir}
  make
  make documentation
  ln -sf shlib/libreadline.so.%{rl_vers} libreadline.so
  ln -sf shlib/libreadline.so.%{rl_vers} libreadline.so.4
  ln -sf shlib/libhistory.so.%{rl_vers} libhistory.so
  ln -sf shlib/libhistory.so.%{rl_vers} libhistory.so.4
cd ../bash-%{bash_vers}
  ln -sf ../readline-%{rl_vers} readline
  CC="gcc -I$PWD -L$PWD/../readline-%{rl_vers}"
  export LD_LIBRARY_PATH=$PWD/../readline-%{rl_vers}
%{?suse_update_config:%{suse_update_config -f support}}
  #
  # We have a malloc with our glibc
  #
  SYSMALLOC="
	--without-gnu-malloc
	--without-glibc-malloc
  "
  #
  # System readline library (comment out it not to be used)
  #
  READLINE="
	--with-installed-readline
  "
  bash support/mkconffiles -v
  autoconf
  ./configure --build=%{_target_cpu}-suse-linux	\
	--prefix=/usr			\
	--mandir=%{_mandir}		\
	--infodir=%{_infodir}		\
	--libdir=%{_libdir}		\
	--with-curses			\
	$SYSMALLOC			\
	--enable-job-control		\
	--enable-alias			\
	--enable-readline		\
	--enable-history		\
	--enable-bang-history		\
	--enable-directory-stack	\
	--enable-process-substitution	\
	--enable-prompt-string-decoding	\
	--enable-select			\
	--enable-help-builtin		\
	--enable-array-variables	\
	--enable-brace-expansion	\
	--enable-command-timing		\
	--enable-disabled-builtins	\
	$READLINE
  make
  make documentation

%install
  make install DESTDIR=$RPM_BUILD_ROOT
  make install-shared libdir=/%{_lib} linkagedir=%{_libdir} DESTDIR=$RPM_BUILD_ROOT
  rm -rf $RPM_BUILD_ROOT%{_defaultdocdir}/bash
  mkdir -p $RPM_BUILD_ROOT%{_defaultdocdir}/bash
  install -m 644 doc/*.html     $RPM_BUILD_ROOT%{_defaultdocdir}/bash/
  chmod 0755 $RPM_BUILD_ROOT/%{_lib}/libhistory.so.%{rl_vers}
  chmod 0755 $RPM_BUILD_ROOT/%{_lib}/libreadline.so.%{rl_vers}
  strip $RPM_BUILD_ROOT/%{_lib}/libhistory.so.%{rl_vers}
  strip $RPM_BUILD_ROOT/%{_lib}/libreadline.so.%{rl_vers}
  rm -f $RPM_BUILD_ROOT/%{_lib}/libhistory.so.%{rl_vers}*old
  rm -f $RPM_BUILD_ROOT/%{_lib}/libreadline.so.%{rl_vers}*old
cd ../bash-%{bash_vers}
  #make install
  make install-strip DESTDIR=$RPM_BUILD_ROOT
  mkdir -p $RPM_BUILD_ROOT/bin
  mv $RPM_BUILD_ROOT/usr/bin/bash $RPM_BUILD_ROOT/bin/
  ln -sf bash $RPM_BUILD_ROOT/bin/sh
  ln -sf ../../bin/bash $RPM_BUILD_ROOT/usr/bin/rbash
  install -m 644 COMPAT NEWS    $RPM_BUILD_ROOT%{_defaultdocdir}/bash/
  install -m 644 COPYING        $RPM_BUILD_ROOT%{_defaultdocdir}/bash/
  install -m 644 doc/FAQ        $RPM_BUILD_ROOT%{_defaultdocdir}/bash/
  install -m 644 doc/INTRO      $RPM_BUILD_ROOT%{_defaultdocdir}/bash/
  install -m 644 doc/*.html     $RPM_BUILD_ROOT%{_defaultdocdir}/bash/
  install -m 644 doc/builtins.1 $RPM_BUILD_ROOT%{_mandir}/man1/bashbuiltins.1
  install -m 644 doc/rbash.1    $RPM_BUILD_ROOT%{_mandir}/man1/rbash.1
  gzip -9f $RPM_BUILD_ROOT%{_infodir}/*.inf*[^z] || true
  X=""
set -f
  (cat - > $RPM_BUILD_ROOT%{_defaultdocdir}/bash/BUGS) <<-EOF
Known problems
--------------
$X 
This version of bash/readline supports multi byte handling
that is e.g. wide character support for UTF-8.  This cause
problems in geting the current cursor position within the
readline runtime library:
$X 
bash-%{bash_vers}> LANG=ja_JP
bash-%{bash_vers}> echo -n "Hello"
bash-%{bash_vers}>
$X 
in other words the prompt overwrites the output of the
echo comand.  The boolean variable byte-oriented
set in /etc/inputrc or \$HOME/.inputrc avoids this
but disable multi byte handling.
$X 
EOF
set +f

%files
%defattr(-,root,root)
/bin/bash
/bin/sh
/usr/bin/bashbug
/usr/bin/rbash
%doc %{_infodir}/bash.info.gz
%doc %{_mandir}/man1/bash.1.gz
%doc %{_mandir}/man1/bashbuiltins.1.gz
%doc %{_mandir}/man1/bashbug.1.gz
%doc %{_mandir}/man1/rbash.1.gz
%doc %{_defaultdocdir}/bash/

%files -n readline
%defattr(-,root,root)
/%{_lib}/libhistory.so.4
/%{_lib}/libhistory.so.%{rl_vers}
/%{_lib}/libreadline.so.4
/%{_lib}/libreadline.so.%{rl_vers}
%doc %{_infodir}/history.info.gz
%doc %{_infodir}/readline.info.gz

%files -n readline-devel
%defattr(-,root,root)
/usr/include/readline/
%{_libdir}/libhistory.a
%{_libdir}/libhistory.so
%{_libdir}/libreadline.a
%{_libdir}/libreadline.so
%doc %{_mandir}/man3/readline.3.gz

%changelog -n bash
* Wed Dec 20 2006 - hhetter@suse.de
- PTF for bug #37917
* Thu Feb 13 2003 - schwab@suse.de
- Fix prompt decoding with -noediting.
* Tue Feb 11 2003 - kukuk@suse.de
- To avoid loop in PreRequires, don't install info pages. The info
  package contains a dir file which contains the bash entries
  already.
* Fri Feb 07 2003 - ro@suse.de
- fixed specfile
* Fri Feb 07 2003 - ro@suse.de
- added install_info macros
* Mon Jan 27 2003 - schwab@suse.de
- Fix bugs #21096 and #21392 properly: don't recurse on
  do-lowercase-version for fallback entry.
* Tue Jan 21 2003 - werner@suse.de
- Allow rbash as login shell (`-' problem, bug #22917)
* Wed Dec 18 2002 - schwab@suse.de
- Use BuildRoot.
* Thu Dec 12 2002 - mfabian@suse.de
- add bash-2.05b-display-mbspeed.patch received from
  Jiro SEKIBA <jir@yamato.ibm.com> to improve display speed in
  multibyte locales.
* Sat Nov 09 2002 - ro@suse.de
- add bison to neededforbuild for now
  (till we're sure about bison again)
* Thu Oct 31 2002 - werner@suse.de
- For bug #21096 and #21392: implement an oom protection.
* Mon Oct 21 2002 - werner@suse.de
- More for bug#21096: Make prefix-meta work even if mapped onto
  longer escape sequences.
* Fri Oct 18 2002 - werner@suse.de
- Fix bug#21096: sequences like `ESC ... CHARACTER' with CHARACTER
  mapped on functions will not cause an endless recursion anymore.
* Wed Sep 25 2002 - ro@suse.de
- removed more bogus provides
* Wed Sep 11 2002 - werner@suse.de
- Correct Provides (package should not provides its self)
* Fri Aug 30 2002 - werner@suse.de
- Add version dependend require on readline (bug #18652)
* Fri Aug 30 2002 - werner@suse.de
- Fix annoying display bug in wide character support (bug #18449)
* Wed Aug 28 2002 - werner@suse.de
- Add comment about multi byte handling and echo builtin (#18449)
* Wed Aug 21 2002 - mls@suse.de
- fix $RANDOM randomness in subshells
* Fri Aug 09 2002 - kukuk@suse.de
- readline-devel should require readline
* Mon Jul 29 2002 - werner@suse.de
- Expansion of `~user/<dir>' is like `/<dir>'
* Sat Jul 27 2002 - kukuk@suse.de
- Remove not used tetex from neededforbuild
- Fix building of man2html (bash.html still broken)
* Fri Jul 19 2002 - werner@suse.de
- Check value of LANG before LC_ALL will be unset for getting the
  _current_ default value of LC_ALL with setlocale(3) (bug #16999)
* Fri Jul 19 2002 - werner@suse.de
- Fix NULL pointer handled by memset (readline:mbutil.c)
* Thu Jul 18 2002 - werner@suse.de
- Update to new version bash 2.05b/readline 4.3
* Wed May 22 2002 - schwab@suse.de
- Fix vi-change-char.
- Fix missing declaration.
* Wed Apr 17 2002 - schwab@suse.de
- Fix last change.
* Thu Apr 11 2002 - sf@suse.de
- using %%{_libdir} to put the shlibs into the correct directories
  (lib / lib64)
* Tue Mar 26 2002 - werner@suse.de
- Fix possible endless loop if terminal will be disconneted during
  complete answer (bug report from bastian@kde.org, for more see
  http://bugs.kde.org/db/37/37999.html)
* Wed Mar 20 2002 - ro@suse.de
- removed tetex from neededforbuild, it's not used here
* Wed Mar 06 2002 - werner@suse.de
- Use improved bug fix for line wrapping problem, now line wrapping
  work for char and wide char environments
- Fix readline version number
* Wed Feb 27 2002 - mfabian@suse.de
- add readline-4.2-i18n-0.3-display.patch from
  Jiro SEKIBA <jir@yamato.ibm.com> to fix a line wrapping
  problem.
* Mon Jan 21 2002 - werner@suse.de
- Fix bug #12834: Update to bash-2.05-i18n-0.5.patch.gz and
  bash-2.05-readline-i18n-0.3.patch.gz
* Thu Oct 18 2001 - werner@suse.de
- Allways include /etc/inputrc if INPUTRC isn't system file
* Mon Oct 08 2001 - werner@suse.de
- Fix readline i18n patch: enable configure of multi byte handling,
  fix warnings and bug in histexpand.c
* Fri Oct 05 2001 - werner@suse.de
- Add two patches for I18N support of bash and readline library
* Tue Sep 04 2001 - werner@suse.de
- Add patch to avoid trouble with C++ header definitions
* Fri Aug 03 2001 - werner@suse.de
- Fix fc crash (bug #9620)
* Mon Jul 02 2001 - olh@suse.de
- dont apply bash-2.05-s390x-unwind.patch on ppc and sparc
* Thu Jun 14 2001 - bk@suse.de
- fix 64-bit bigendian bug for s390x
* Wed Jun 06 2001 - werner@suse.de
- Re-order configure.in to avoid trouble with new autoconf
* Tue May 08 2001 - mfabian@suse.de
- bzip2 sources
* Sat May 05 2001 - schwab@suse.de
- Fix process substitution when stdin is closed.
* Wed May 02 2001 - werner@suse.de
- Make patch for 2.4.4 work within spec
* Wed May 02 2001 - werner@suse.de
- Remove buggy patch in job control, add a workaround
* Mon Apr 30 2001 - werner@suse.de
- Add patch to get job control into right order on a pipe
* Thu Apr 12 2001 - werner@suse.de
- Provide cpp macro OLD_READLINE for backwards compatibility
  at compile time with old readline interface
* Thu Apr 12 2001 - ro@suse.de
- added split-alias as provides (again)
* Wed Apr 11 2001 - werner@suse.de
- Update to bash 2.05 and readline 4.2
- Port of our patches
* Thu Feb 22 2001 - werner@suse.de
- Split package into bash/readline/readline-devel
- Depend libreadline on libncurses
* Thu Sep 14 2000 - werner@suse.de
- Add some bug fixes
- Add missed ssh fix for none interactive shell
* Wed Jun 07 2000 - werner@suse.de
- Fix some patches
- Add export patch for bash 2.04
- Fix `soname' of readline and history libraries
- Fix linkage of major readline and history libraries
* Mon Jun 05 2000 - schwab@suse.de
- Fix unwind_protect_pointer on 64-bit systems.
* Wed May 31 2000 - schwab@suse.de
- Comment out declaration of savestring in <readline.h> that conflicts
  with other people's declaration (eg. gdb).
* Mon May 29 2000 - aj@suse.de
- Upgrade to bash 2.04 and readline 4.1.
* Sun May 21 2000 - kukuk@suse.de
- Use docdir
* Sat Apr 01 2000 - bk@suse.de
- remove obviosly unneeded link /usr/lib/libreadline.so on s390
* Tue Mar 14 2000 - werner@suse.de
- Add locale patch to enable LC_NUMERIC handling
* Thu Feb 24 2000 - werner@suse.de
- Use $VENDOR for several linux architectures
- Set check_window_size (shopt checkwinsize) to true, this will
  correct screen size even if it changes during a job.
* Tue Feb 15 2000 - schwab@suse.de
- Update config.{guess,sub} to latest version.
- Fix spec file to create doc directory before installing into it.
* Fri Jan 28 2000 - werner@suse.de
- Add mailstat patch (handles mail directories)
- Fix configuration (system is %%arch-suse-linux)
- Fix segfault (job handling)
- Fix manual (add rbash manual, add some missed options)
- Install rbash (symlink to bash)
- Fix readline (End, Del)
- Fix temporary file handling (do not write without check)
- Use system random interface not builtin
- Remove some compiler warnings
- Set --enable-disabled-builtins (useful)
- Install shared readline and history in /lib (bash needs that)
- Enable shared readline (version 4.0) and history library
- Try to use shared readline and history for bash (TEST)
* Fri Dec 03 1999 - kasal@suse.de
- added command to make and install doc/bashref.html
* Fri Nov 26 1999 - kukuk@suse.de
- Fix spec file
* Thu Nov 25 1999 - kukuk@suse.de
- Merge Makefile.Linux with spec file, use RPM_OPT_FLAGS
- Remove --disable-dparen-arithmetic
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Tue Aug 24 1999 - uli@suse.de
- fixed for PPC
* Mon Jul 19 1999 - florian@suse.de
- update to bash 2.03, readline 4.0
* Wed Jan 13 1999 - @suse.de
- disabled `Broken pipe' messages
* Sun Dec 13 1998 - bs@suse.de
- removed notify message - bash 2.0 is standard for a long time now.
* Mon Dec 07 1998 - florian@suse.de
- remove SSH_CLIENT-kludge as this cannot detect all correct cases
  where .bashrc should be loaded
- delete email-changes in bashbug script
- update readline to version 2.2.1
* Thu Nov 12 1998 - bs@suse.de
- minor fix for new rpm
* Thu Oct 01 1998 - ro@suse.de
- update to 2.02.1 / reintegrated werner's tmp-fix for bashbug
* Thu Jul 23 1998 - werner@suse.de
- use mktemp
* Thu Jul 16 1998 - werner@suse.de
- fix bashbug temp file handling
* Wed Jun 17 1998 - ro@suse.de
- changed general.h: !defined (gid_t)
* Mon Oct 27 1997 - florian@suse.de
- do not include old compatible-only safestring() in libreadline.a
* Thu Oct 09 1997 - florian@suse.de
- update to version 2.01.1
- add several bugfixes
- fix missing things in spec-file
* Thu Aug 14 1997 - florian@suse.de
- add several bug-fixes from gnu.bash.bug and fix memory management
  of LC_ALL
* Sat Jul 05 1997 - florian@suse.de
- add another bugfix from gnu.utils.bugs
* Mon Jun 23 1997 - florian@suse.de
- create the history file with 0600 perms
- add minor bugfix to check for new email
* Thu Jun 05 1997 - florian@suse.de
- update to bash 2.01 and readline 2.1
- add more documentation files in /usr/doc
- bash: check for NULL-pointer before calling "savestring()"
- add bashref.info and newer FAQ
* Tue Apr 22 1997 - bs@suse.de
- added FAQ and bashref.html to /usr/doc/packages/bash
* Sun Apr 13 1997 - florian@suse.de
- update to bash 2.0 with lots of patches from gnu.utils.bugs
  Mon Sep  2 02:48:35 MET DST 1996
  new version with security patches
* Thu Jan 02 1997 - florian@suse.de
  security fix included (0xff was command separator)
